Module org.apache.sis.referencing
Package org.apache.sis.referencing.crs

# Class DefaultGeocentricCRS

Object
FormattableObject
AbstractIdentifiedObject
AbstractReferenceSystem
AbstractCRS
DefaultGeocentricCRS

All Implemented Interfaces:
  `Serializable`, `Formattable`, `Deprecable`, `LenientComparable`, `CoordinateReferenceSystem`, `GeocentricCRS`, `GeodeticCRS`, `SingleCRS`, `IdentifiedObject`, `ReferenceSystem`

public class DefaultGeocentricCRS extends AbstractCRS implements GeocentricCRS
A 3-dimensional coordinate reference system with the origin at the approximate centre of mass of the earth. A geocentric CRS deals with the earth's curvature by taking a 3-dimensional spatial view, which obviates the need to model the earth's curvature.

Used with datum type: Geodetic.
Used with coordinate system types: Cartesian or Spherical.

## Creating new geocentric CRS instances

New instances can be created either directly by specifying all information to a factory method (choices 3 and 4 below), or indirectly by specifying the identifier of an entry in a database (choices 1 and 2 below). Choice 1 in the following list is the easiest but most restrictive way to get a geocentric CRS. The other choices provide more freedom.

1. Create a `GeocentricCRS` from one of the static convenience shortcuts listed in `CommonCRS​.geocentric()`.
2. Create a `GeocentricCRS` from an identifier in a database by invoking `GeodeticAuthorityFactory​.createGeocentricCRS(String)`.
3. Create a `GeocentricCRS` by invoking the `CRSFactory​.createGeocentricCRS(…)` method (implemented for example by `GeodeticObjectFactory`).
4. Create a `GeocentricCRS` by invoking the constructor.

Example: the following code gets a geocentric CRS using the World Geodetic System 1984 datum:

    GeodeticDatum datum = CommonCRS.WGS84.geocentric();

## Immutability and thread safety

This class is immutable and thus thread-safe if the property values (not necessarily the map itself), the coordinate system and the datum instances given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.

Since:
  0.4
See Also:
  - `GeodeticAuthorityFactory​.createGeocentricCRS(String)`
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class AbstractIdentifiedObject

  `DEPRECATED_KEY, LOCALE_KEY`

  ### Fields inherited from interface IdentifiedObject

  `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

  ### Fields inherited from interface ReferenceSystem

  `DOMAIN_OF_VALIDITY_KEY, SCOPE_KEY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  ``
  `DefaultGeocentricCRS(Map<String,?> properties, GeodeticDatum datum, CartesianCS cs)`
  Creates a coordinate reference system from the given properties, datum and coordinate system.
  ``
  `DefaultGeocentricCRS(Map<String,?> properties, GeodeticDatum datum, SphericalCS cs)`
  Creates a coordinate reference system from the given properties, datum and coordinate system.
  `protected`
  `DefaultGeocentricCRS(GeocentricCRS crs)`
  Constructs a new coordinate reference system with the same values than the specified one.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultGeocentricCRS`
  `castOrCopy(GeocentricCRS object)`
  Returns a SIS coordinate reference system implementation with the same values than the given arbitrary implementation.
  `DefaultGeocentricCRS`
  `forConvention(AxesConvention convention)`
  Returns a coordinate reference system equivalent to this one but with axes rearranged according the given convention.
  `protected String`
  `formatTo(Formatter formatter)`
  Formats this CRS as a Well Known Text `GeodeticCRS[…]` element.
  `final GeodeticDatum`
  `getDatum()`
  Returns the geodetic datum associated to this geocentric CRS.
  `Class<? extends GeocentricCRS>`
  `getInterface()`
  Returns the GeoAPI interface implemented by this class.

  ### Methods inherited from class AbstractCRS

  `castOrCopy, computeHashCode, equals, getCoordinateSystem`

  ### Methods inherited from class AbstractReferenceSystem

  `getDomainOfValidity, getScope`

  ### Methods inherited from class AbstractIdentifiedObject

  `castOrCopy, equals, formatTo, getAlias, getDescription, getDomains, getIdentifiers, getName, getRemarks, hashCode, isDeprecated, isHeuristicMatchForName`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface GeocentricCRS

  `getCoordinateSystem`

  ### Methods inherited from interface IdentifiedObject

  `getAlias, getIdentifiers, getName, getRemarks, toWKT`

  ### Methods inherited from interface ReferenceSystem

  `getDomainOfValidity, getScope`

- ## Constructor Details

  - ### DefaultGeocentricCRS

    public DefaultGeocentricCRS(Map<String,?> properties, GeodeticDatum datum, CartesianCS cs)
    Creates a coordinate reference system from the given properties, datum and coordinate system. The properties given in argument follow the same rules than for the super-class constructor. The following table is a reminder of main (not all) properties:

    Recognized properties (non exhaustive list)
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `ReferenceIdentifier` or `String` | `AbstractIdentifiedObject.getName()`
    "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
    "identifiers" | `ReferenceIdentifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
    "domains" | `DefaultObjectDomain` (optionally as array) | `AbstractIdentifiedObject.getDomains()`
    "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`

    Parameters:
      `properties` - the properties to be given to the coordinate reference system.
      `datum` - the datum.
      `cs` - the coordinate system, which must be three-dimensional.
    See Also:
      - `GeodeticObjectFactory​.createGeocentricCRS(Map, GeodeticDatum, CartesianCS)`

  - ### DefaultGeocentricCRS

    public DefaultGeocentricCRS(Map<String,?> properties, GeodeticDatum datum, SphericalCS cs)
    Creates a coordinate reference system from the given properties, datum and coordinate system. The properties given in argument are the same than for the above constructor.
    Parameters:
      `properties` - the properties to be given to the coordinate reference system.
      `datum` - the datum.
      `cs` - the coordinate system.
    See Also:
      - `GeodeticObjectFactory​.createGeocentricCRS(Map, GeodeticDatum, SphericalCS)`

  - ### DefaultGeocentricCRS

    protected DefaultGeocentricCRS(GeocentricCRS crs)
    Constructs a new coordinate reference system with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

    This constructor performs a shallow copy, i.e. the properties are not cloned.

    Parameters:
      `crs` - the coordinate reference system to copy.
    See Also:
      - `castOrCopy(GeocentricCRS)`

- ## Method Details

  - ### castOrCopy

    public static DefaultGeocentricCRS castOrCopy(GeocentricCRS object)
    Returns a SIS coordinate reference system implementation with the same values than the given arbitrary implementation. If the given object is `null`, then this method returns `null`. Otherwise if the given object is already a SIS implementation, then the given object is returned unchanged. Otherwise a new SIS implementation is created and initialized to the attribute values of the given object.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getInterface

    public Class<? extends GeocentricCRS> getInterface()
    Returns the GeoAPI interface implemented by this class. The SIS implementation returns `GeocentricCRS​.class`.

    #### Note for implementers

    Subclasses usually do not need to override this method since GeoAPI does not define `GeocentricCRS` sub-interface. Overriding possibility is left mostly for implementers who wish to extend GeoAPI with their own set of interfaces.
    Returns:
      `GeocentricCRS​.class` or a user-defined sub-interface.

  - ### getDatum

    public final GeodeticDatum getDatum()
    Returns the geodetic datum associated to this geocentric CRS. This is the datum given at construction time.
    Specified by:
      `getDatum` in interface `GeodeticCRS`
    Specified by:
      `getDatum` in interface `SingleCRS`
    Returns:
      the geodetic datum associated to this geocentric CRS.

  - ### forConvention

    public DefaultGeocentricCRS forConvention(AxesConvention convention)
    Returns a coordinate reference system equivalent to this one but with axes rearranged according the given convention. If this CRS is already compatible with the given convention, then this method returns `this`.
    Overrides:
      `forConvention` in class `AbstractCRS`
    Parameters:
      `convention` - the axes convention for which a coordinate reference system is desired.
    Returns:
      a coordinate reference system compatible with the given convention (may be `this`).
    See Also:
      - `AbstractCS​.forConvention(AxesConvention)`

  - ### formatTo

    protected String formatTo(Formatter formatter)
    Formats this CRS as a Well Known Text `GeodeticCRS[…]` element.

    #### Example

    Well-Known Text (version 2) of a geocentric coordinate reference system using the WGS 84 datum.

        GeodeticCRS["Geocentric",
          Datum["World Geodetic System 1984",
            Ellipsoid["WGS84", 6378137.0, 298.257223563, LengthUnit["metre", 1]]],
            PrimeMeridian["Greenwich", 0.0, AngleUnit["degree", 0.017453292519943295]],
          CS["Cartesian", 3],
            Axis["(X)", geocentricX],
            Axis["(Y)", geocentricY],
            Axis["(Z)", geocentricZ],
            LengthUnit["metre", 1]]

    Same coordinate reference system using WKT 1. Note that axis directions are totally different.

        GEOCCS["Geocentric",
          DATUM["World Geodetic System 1984",
            SPHEROID["WGS84", 6378137.0, 298.257223563]],
            PRIMEM["Greenwich", 0.0],
          UNIT["metre", 1],
          AXIS["X", OTHER],
          AXIS["Y", EAST],
          AXIS["Z", NORTH]]

    Parameters:
      `formatter` - the formatter where to format the inner content of this WKT element.
    Returns:
      `"GeodeticCRS"` (WKT 2) or `"GeocCS"` (WKT 1).
    See Also:
      - WKT 2 specification §8